GEOS: geos::geom::CoordinateSequenceFilter Class Reference

Public Member Functions

# geos::geom::CoordinateSequenceFilter Class Reference

`#include <CoordinateSequenceFilter.h>`

Inherited by geos::algorithm::distance::DiscreteHausdorffDistance::MaxDensifiedByFractionDistanceFilter.

List of all members.

## Public Member Functions
virtual void | filter_rw (CoordinateSequence &, std::size_t)
virtual void | filter_ro (const CoordinateSequence &, std::size_t)
virtual bool | isDone () const =0
virtual bool | isGeometryChanged () const =0

## Detailed Description

Interface for classes which provide operations that can be applied to the coordinates in a CoordinateSequence. A CoordinateSequence filter can either record information about each coordinate or change the coordinate in some way. CoordinateSequence filters can be used to implement such things as coordinate transformations, centroid and envelope computation, and many other functions. For maximum efficiency, the execution of filters can be short-circuited. Geometry classes support the concept of applying a `CoordinateSequenceFilter` to each CoordinateSequences they contain.

`CoordinateSequenceFilter` is an example of the Gang-of-Four Visitor pattern.

See also:
  Geometry::apply_ro(CoordinateSequenceFilter)
  Geometry::apply_rw(CoordinateSequenceFilter)

Author:
  Martin Davis

## Member Function Documentation

virtual void geos::geom::CoordinateSequenceFilter::filter_ro | ( | const CoordinateSequence & | ,
|  | std::size_t |
| ) |  | `[inline, virtual]`

Performs an operation on a coordinate in a CoordinateSequence.

Parameters:

  seq | the `CoordinateSequence` to which the filter is applied
  i | the index of the coordinate to apply the filter to

virtual void geos::geom::CoordinateSequenceFilter::filter_rw | ( | CoordinateSequence & | ,
|  | std::size_t |
| ) |  | `[inline, virtual]`

Performs an operation on a coordinate in a CoordinateSequence.

Parameters:

  seq | the `CoordinateSequence` to which the filter is applied
  i | the index of the coordinate to apply the filter to

virtual bool geos::geom::CoordinateSequenceFilter::isDone | ( | ) | const`[pure virtual]`

Reports whether the application of this filter can be terminated. Once this method returns `false`, it should continue to return `false` on every subsequent call.

Returns:
  true if the application of this filter can be terminated.

virtual bool geos::geom::CoordinateSequenceFilter::isGeometryChanged | ( | ) | const`[pure virtual]`

Reports whether the execution of this filter has modified the coordinates of the geometry. If so, Geometry#geometryChanged will be executed after this filter has finished being executed.

Most filters can simply return a constant value reflecting whether they are able to change the coordinates.

Returns:
  true if this filter has changed the coordinates of the geometry

The documentation for this class was generated from the following file:

- CoordinateSequenceFilter.h